<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    :ok-text="isNew ? 'Добавить' : 'Изменить'"
    @submit="onSaveForm"
    class="group-form"
  >
    <div class="group-form__row order-method-options">
      <div class="order-method-options__service">
        <ob-select
            v-model="formData.activeTransport"
            label="Услуга"
            :items="transports"
            placeholder="Выберите из списка"
            position="top"
            :isStandart="true"
            :disabled="transports.length === 1"
            popperClass="transport-type-popper"
            data-qa="tms-transportKind"
            @selected="changeTransport"
            required
        />
      </div>
      <div class="order-method-options__transport">
        <ob-select
            v-model="formData.activeTransportType"
            class="transport-type-select"
            :label="$options.transportLabels[activeTransportationWay].subtype"
            :items="transportsTypesGrouped"
            placeholder="Выберите из списка"
            position="top"
            :isStandart="false"
            required
            data-qa="tms-transportType"
        />
      </div>
    </div>

    <div class="group-form__row">
      <h2>Исполнители</h2>
    </div>

    <div class="group-form__row">
      <ob-select
        label="Исполнители"
        placeholder="Выберите один или несколько вариантов"
        v-model="formData.contractors"
        :items="contractors"
        :isDropdown="true"
        isAutoComplete
        :disabled="rule.titul.status === 'ACTIVE' || rule.titul.status === 'TERMINATED' || rule.titul.status === 'REMOVED'"
        property="description"
        subTitleExp="inn"
        :two-rows="true"
        required
        data-qa="tms-contractors"
      />
    </div>
  </ob-form>
</template>

<script>
import { uuid } from "vue-uuid";
import { mapGetters } from 'vuex';
import api from '@/api';
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import ObForm from "common-components/src/obComponents/obForm";
import ObSelect from "common-components/src/obComponents/obSelect";
import { required } from "vuelidate/lib/validators";

export default {
  name: 'serviceModal',

  transportLabels: {
    FTL: {
      label: "Какой автотранспорт",
      type: "Вид автотранспорта",
      subtype: "Тип автотранспорта",
    },
    CONTAINER: {
      label: "Какие контейнеры",
      type: "Вид контейнера",
      subtype: "Тип контейнера",
    },
    RAIL: {
      label: "Какой ЖД транспорт",
      type: "Вид ЖД транспорта",
      subtype: "Тип ЖД транспорта",
    },
  },

  props: {
    contractors: {
      type: Array
    }
  },

  components: {
    ObForm,
    ObSelect,
  },

  mixins: [FormValidationMixin],

  data() {
    return {
      transports: [],
      transportTypes: [],
      transportsTypesGrouped: [],
      activeTransportationWay: "FTL",
    }
  },

  computed: {
    ...mapGetters({
      rule: 'tms/rule'
    }),

    formModel() {
      return {
        uuid: {
          value: ''
        },
        activeTransport: {
          value: '',
          validator: {
            required
          }
        },
        activeTransportType: {
          value: '',
          validator: {
            required
          }
        },
        contractors: {
          value: [],
          validator: {
            required
          }
        }
      }
    },

    isNew() {
      return !this.formData.uuid;
    },
  },

  watch: {
    dataSource () {
      this.onLoadSaved();
      this.generateForm();
    }
  },

  mounted() {
    this.setTransports();
    this.onLoadSaved();
  },

  methods: {

    onLoadSaved() {
      if (this.dataSource && this.dataSource.activeTransportType) {
        this.setServicesAll(this.dataSource.activeTransportType);
      }
    },

    async onSaveForm (data) {
      await this.savePolicyServices(data);
    },

    async savePolicyServices(data) {
      const newUuid = this.isNew ? uuid.v4() : this.formData.uuid;
      const payload = {
        serviceUuid: this.formData.activeTransportType,
        serviceUnitUuid: this.transportsTypes.find(item => item.uuid === this.formData.activeTransportType)?.serviceUnits[0].uuid,
        policyUuid: this.rule.uuid,
        participantUuids: data.contractors

      }

      try {
        await api.tms.savePolicyServices(newUuid, payload);
        this.$emit('submitted', newUuid);
      } catch (e) {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка при совершении операции"
        });
      }
    },

    async setTransports() {
      try {
        this.transports = await api.orders.getTransport(
            this.activeTransportationWay
        );
        if (!this.formData.activeTransportType) {
          this.formData.activeTransport = this.transports[0].uuid;
          this.changeTransport();
        }
      } catch (err) {
        console.error(err);
      }
    },

    async setServicesAll(serviceUuid) {
      const params = serviceUuid ?
          {
            isActive: true,
            serviceUuids: [ serviceUuid ]
          } :
          {
            isActive: true,
            serviceTypeUuids: [ this.formData.activeTransport ]
          }
      try {
        const types = await api.services.getServicesAll(params);
        this.transportsTypes = types;
        this.transportsTypesGrouped = this.groupTransportTypes(types);
        if (serviceUuid) {
          this.formData.activeTransport = this.transportsTypes[0]?.serviceTypeUuid;
          this.changeTransport();
        }
      } catch (err) {
        console.error(err);
      }
    },

    groupTransportTypes(types) {
      const GROUP_SIZE_MIN = 6;
      let groups = [];
      const groupsMap = {};
      if (types) {
        if (types.length > GROUP_SIZE_MIN) {
          types.forEach(type => {
            if (!groupsMap[type.resourceSubtypeUuid]) {
              groupsMap[type.resourceSubtypeUuid] = {
                title: type.resourceSubtypeTitle,
                hideSelectButton: true,
                defaultGroupElementUuid: type.resourceSubtypeUuid,
                children: []
              };
            }
            type.title = this.getTransportItemTitle(type);
            groupsMap[type.resourceSubtypeUuid].children.push(type);
          })

          Object.keys(groupsMap).forEach(key => {
            let group = groupsMap[key];
            let defaulItem = group.children.filter(item => item.isDefaultForSubtype);
            if (defaulItem.length === 1) {
              group.defaultGroupElementUuid = defaulItem[0].uuid;
              group.hideSelectButton = false;
            }
            groups.push(group);
          })
        } else {
          groups = types.map(type => {
            type.title = this.getTransportItemTitle(type);
            return type;
          });
        }
      }

      return groups;
    },

    getTransportItemTitle (item) {
      return item.resourceSubtypeTitle + " " + item.resourcePatternParameter;
    },

    changeTransport() {
      this.setServicesAll();
    },
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";
@import '~common-components/src/static/css/variables';

.group-form__row {
  margin-bottom: 20px;
}

h2 {
  @include font-mixin(16px, 20px, 700, $color-text-base);
}

.select-item {
  width: 100%;
  padding: 8px 12px;
  display: flex;
  justify-content: space-between;
  @include font-mixin(16px, 20px, 400, $color-text-base);
  cursor: pointer;

  &:hover {
    background-color: $blue-blue-hoarfrost;
  }
}

.order-method-options {
  display: flex;
  margin-bottom: 30px;
  margin-top: 20px;

  &__service {
    margin-right: 10px;
    width: 33%;
    display: flex;
    min-width: 250px;

    .ob-selector {
      width: 100%;
    }
  }

  &__service {
    margin-right: 10px;
  }

  &__transport {
    flex-grow: 1;
  }
}

</style>
